VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Pie-Demo"
   ClientHeight    =   2820
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4155
   LinkTopic       =   "Form1"
   ScaleHeight     =   2820
   ScaleWidth      =   4155
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'Kein
      Height          =   2535
      Left            =   120
      ScaleHeight     =   169
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   265
      TabIndex        =   0
      Top             =   120
      Width           =   3975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Autor: Jan Thiede
'E-Mail: jan.thiede@web.de
'Hinweis: Teile dieser Source wurden aus einer Delphi-Funktion nach VB umgeschrieben

Option Explicit

Private Declare Function Pie Lib "gdi32" ( _
    ByVal hdc As Long, ByVal X1 As Long, _
    ByVal Y1 As Long, ByVal X2 As Long, _
    ByVal Y2 As Long, ByVal X3 As Long, _
    ByVal Y3 As Long, ByVal X4 As Long, _
    ByVal Y4 As Long) As Long
    
Private Const PI = 3.14159265


Public Sub PaintPie(ByRef oPicBox As PictureBox, _
    ByVal dblValue As Double, _
    ByVal dblMax As Double)
    
    Dim nWidth As Integer, nHeight As Integer, nDeep As Integer
    Dim nLeft As Integer, nTop As Integer
    
    Dim nWinkel As Double, nGrad As Double
    Dim dblX1 As Double, dblY1 As Double
    
    Dim i As Integer
    
    'Farben
    Const DarkMagenta = 8388736
    Const DarkBlue = 8388608
    
    With oPicBox
    'Ein paar Einstellungen setzen
    .Cls
    .AutoRedraw = True
    .ScaleMode = vbPixels
    .ForeColor = vbBlack
    .DrawWidth = 1
    .FillStyle = vbSolid

    'Die Hhe des Kuchens
    nDeep = 10
    
    'Koordinaten errechnen
    nWidth = oPicBox.ScaleHeight + Int(oPicBox.ScaleHeight / 2) - 20
    nHeight = oPicBox.ScaleHeight - 20
    nLeft = (oPicBox.ScaleWidth / 2) - (nWidth / 2)
    nTop = (oPicBox.ScaleHeight / 2) - (nHeight / 2)
    
    'Winkel im Gradma errechnen
    nWinkel = (dblValue / dblMax) * 360
    nGrad = Int(nWinkel - 270)
    
    'Koordinaten
    dblX1 = nWidth * Sin(((nGrad * PI) / 180))
    dblY1 = nHeight * Cos(((nGrad * PI) / 180))

    If nWinkel = 360 Then
        'Die unteren Scheiben (fr den 3D-Effekt)
        For i = nDeep To 1 Step -1
            If i < nDeep Then .ForeColor = DarkBlue
            .FillColor = DarkBlue
            
            Pie .hdc, nLeft, nTop + i, nLeft + nWidth, nTop + nHeight + i, nLeft, _
                nTop + (nHeight / 2) + i, nLeft, nTop + (nHeight / 2) + i
        Next i
        
        'Die oberste Scheibe
        .ForeColor = vbBlack
        .FillColor = vbBlue
        Pie .hdc, nLeft, nTop, nLeft + nWidth, nTop + nHeight, nLeft, _
            nTop + (nHeight / 2), nLeft, nTop + (nHeight / 2)
    Else
        'Die unteren Scheiben (fr den 3D-Effekt)
        For i = nDeep To 1 Step -1
            If i < nDeep Then .ForeColor = DarkMagenta
            .FillColor = DarkMagenta
            Pie .hdc, nLeft, nTop + i, nLeft + nWidth, nTop + nHeight + i, nLeft, _
            nTop + (nHeight / 2) + i, nLeft, nTop + (nHeight / 2) + i
            
            If i < nDeep Then .ForeColor = DarkBlue
            .FillColor = DarkBlue
            Pie .hdc, nLeft, nTop + i, nLeft + nWidth, nTop + nHeight + i, nLeft, _
                nTop + (nHeight / 2) + i, nLeft + (nWidth / 2) - Round(dblX1), _
                nTop + (nHeight / 2) - Round(dblY1) + i
        Next i
        
        'Die oberste Scheibe
        .ForeColor = vbBlack
        .FillColor = vbMagenta
        Pie .hdc, nLeft, nTop, nLeft + nWidth, nTop + nHeight, nLeft, _
            nTop + (nHeight / 2), nLeft, nTop + (nHeight / 2)

        .FillColor = vbBlue
        Pie .hdc, nLeft, nTop, nLeft + nWidth, nTop + nHeight, nLeft, _
            nTop + (nHeight / 2), nLeft + (nWidth / 2) - Round(dblX1), _
            nTop + (nHeight / 2) - Round(dblY1)
    End If
    End With
End Sub

Private Sub Form_Load()
    PaintPie Picture1, 33, 100
End Sub
